package revealtextviewwrapper;


import main.java.com.antonionicolaspina.revealtextview.RevealTextView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.Gravity;

import android.graphics.Color;
import android.graphics.Typeface;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;
import android.support.annotation.NonNull;
import android.widget.ImageView;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import java.util.ArrayList;
import java.util.List;


//@Events(values={"like_toggled"})
@Author("Github: Antonio Nicolas Pina, Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("RevealTextView")
@DependsOn(values={"android-support-annotations"})
public class revealTextViewWrapper extends ViewWrapper<RevealTextView> implements DesignerCustomView {

	private BA ba;
	private String eventName;
        private RevealTextView cv;

	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new RevealTextView(ba.context);
                this.setObject(cv);
//              addImage();
//              addListener();
//              addListener2();
 	}




//    @Hide
//    public void addListener(){

//        cv.setCallback(new LikeButtonView.Callback() {
//            @Override
//            public void like_toggled() {

//              if (ba.subExists(eventName + "_like_toggled")) {
//                ba.raiseEvent2(ba, false, eventName + "_like_toggled", true, new Object[0]);
//              }
//            }

//            @Override
//            public void progress_paused() {

//              if (ba.subExists(eventName + "_progress_paused")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_paused", true, new Object[0]);
//              }
//            }

//            @Override
//            public void progress_resumed() {

//              if (ba.subExists(eventName + "_progress_resumed")) {
//                ba.raiseEvent2(ba, false, eventName + "_progress_resumed", true, new Object[0]);
//              }
//            }


//        });
//    }


//      @Hide
//      public void addListener2(){
//        cv.setOnClickListener(new View.OnClickListener() {
//            @Override
//            public void onClick(View v) {
//              if (ba.subExists(eventName + "_button_clicked")) {
//                ba.raiseEvent2(ba, false, eventName + "_button_clicked", true, new Object[0]);
//              }
//            }
//        });
//      }



//    private void addImage() {
//	       int DrawableID = BA.applicationContext.getResources().getIdentifier("placeholder", "drawable", BA.packageName);
//             cv.addImageFrame(DrawableID);
//	       Drawable drawable = BA.applicationContext.getResources().getDrawable(DrawableID);
//             cv.setDrawable(drawable); 
//             cv.setDriveImageModel(new DriveImageModel("main text", "folder text", DrawableID));
//    }


	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

        public void setRevealText(String RevealText) {
                cv.setRevealText(RevealText);
                cv.setGravity(Gravity.CENTER_VERTICAL | Gravity.CENTER_HORIZONTAL);
                cv.invalidate();
        }

        public void setRevealTextSize(float RevealTextSize) {
                cv.setTextSize(RevealTextSize);
                cv.invalidate();
        }

        public void setRevealTextColor(int RevealTextColor) {
                cv.setTextColor(RevealTextColor);
                cv.invalidate();
        }


        public void setRevealAnimationDuration(int animationDuration) {
                cv.setAnimationDuration(animationDuration);
                cv.invalidate();
        }
    
        public void RUN() {
                cv.run();
                cv.invalidate();
        }    


}
